package servidor_cliente_hilos;
import java.io.*;
import java.net.*;
import java.util.Date;
public class Servidor extends Thread {
    Socket skCliente;
    static final int Puerto = 1500;
    public static DataInputStream flujo_entrada;
    public static DataOutputStream flujo_salida;

    public Servidor(Socket sCliente) {
        skCliente=sCliente;
    }

    public static void main( String[] arg ) {
        try{
            //Inicio el servidor en el puerto
            ServerSocket skServidor = new ServerSocket(Puerto);
            System.out.println("Escucho el puerto " +Puerto);
            while(true){
                 //Se conecta un cliente
                Socket skCliente = skServidor.accept(); 
                System.out.println("Cliente conectado");
                //Atiendo al cliente mediante un thread
                new Servidor(skCliente).start();
            }
        } catch (IOException e) {
            System.err.println(e);
        }
    }

    @Override
    public void run(){
        try {
            // Creo los flujos de entrada y salida
            InputStream entrada = skCliente.getInputStream();
            DataInputStream flujo_entrada = new DataInputStream(entrada);
            OutputStream salida = skCliente.getOutputStream();
            DataOutputStream flujo_salida = new DataOutputStream(salida);
            
            flujo_salida.writeUTF("Que fichero se quiere leer?");
            String in = flujo_entrada.readUTF();
            BufferedReader fichero = null;
            try {
                File fich = new File(in);
                if (fich.exists()) { //Si el fichero existe
                    flujo_salida.writeBoolean(true); //Se envia true al cliente
                    fichero = new BufferedReader(new FileReader(flujo_entrada.readUTF()));
                    String linea;
                    while ((linea = fichero.readLine()) != null) { //Se va leyendo el fichero linea a linea
                        flujo_salida.writeUTF(linea);
                    }
                    System.out.println(flujo_entrada.readUTF()); //Recibe del cliente: Fichero leido
                    //Se cierra la conexion
                    flujo_salida.writeUTF("Cliente desconectado");
//                  //Fin atender cliente
                    skCliente.close(); //Se cierra la conexin
                    System.out.println("Cliente desconectado");
                } else { //Si el fichero no existe
                    flujo_salida.writeBoolean(false); //Se envia false al cliente
                    flujo_salida.writeUTF("No existe el fichero");
                    System.out.println(flujo_entrada.readUTF()); //Recibe del cliente: Fichero no leido
                    //Se cierra la conexion
                    flujo_salida.writeUTF("Cliente desconectado");
                    //Fin atender cliente
                    skCliente.close();  //Se cierra la conexin
                    System.out.println("Cliente desconectado");
                }    
            } catch (FileNotFoundException fn) {
                flujo_salida.writeUTF("No se encuentra el fichero");
                System.exit(0);
            } catch (IOException io) {
                flujo_salida.writeUTF("Error de E/S");
                System.exit(0);
            } finally {
                try {
                    fichero.close(); //Se cierre el fichero
                } catch (IOException ex) {
                    System.err.println(ex.getMessage());
                }
            }
        } catch(IOException e) {
            System.out.println(e.getMessage());
        }
    }    
}